
//global variables for the webserver Read/Write
var WriteDataField = {"increment":1, "decrement":2, "serial":3,"fixedValue":4,"standart":5,"readData":6}
var lastNumber1 =0; 
var dataField = new Array(8192); 

//global object for the errorlist int the firmware 
var errorList = new ErrorList();

//class HeadStatus to refresh the head Status on the right side of the page. 
//refreshing with Ajax all second...
function HeadStatus(){
	var HeadType;
	var HeadState;
	var SerialNumberTag;
	var HeadName;
	
	function init()
	{
		HeadType = "";
		HeadState = "";
		SerialNumberTag = "";
		HeadName = ""; 
	}
	function refreshOutput()
	{
		$("#headStatus\\.headType").html(HeadType);
		$("#headStatus\\.headName").html(HeadName);
		$("#headStatus\\.headState").html(HeadState);
		$("#headStatus\\.serialNumberTag").html(SerialNumberTag);			
	}
	this.setHeadStatus = function(headType,headState,serialNumberTag,headName)
	{
		HeadType = headType;
		HeadState = headState;
		SerialNumberTag = serialNumberTag;
		HeadName = headName;
		refreshOutput();
	}
	init();
	
}
	
//implemtation of class Error Log
//handles the writing of data into the textarea of status 
function ErrorLog(){
	var dataField;
	function init()
	{
		dataField = $("#status").val();
	}
	this.writeText = function(data)
	{
		dataField = dataField + data; 
		refreshOutput();
	}
	function refreshOutput()
	{
		$("#status").val(dataField); 	
	}		
	this.clearErrorLog = function()
	{
		$("#status").val("");
		dataField = ""; 
	}
	init(); 
}

//class ErrorList
function ErrorList(){
	var array = new Array();	
	function createErrorList()
	{
		createErrorEntry(0,"0","Operation Completed - no error"); 
		createErrorEntry(1,"1","Data carrier is not in read/write range of the head"); 
		createErrorEntry(2,"2","Read error"); 
		createErrorEntry(3,"3","Tag removed during read access"); 
		createErrorEntry(4,"4","Write error"); 
		createErrorEntry(5,"5","Tag removed during write access"); 
		createErrorEntry(6,"6","UART error"); 
		createErrorEntry(7,"7","Protocol error"); 
		createErrorEntry(8,"8","BCC error"); 
		createErrorEntry(9,"9","No read/write head is connected with the selected port"); 
		createErrorEntry(10,"A","Mulitple tags"); 
		createErrorEntry(11,"E","CRC error"); 	
		createErrorEntry(12,"e","Read/write address is out of data carrier adress range"); 	
		createErrorEntry(13,"P","Port error"); 	
		createErrorEntry(14,"S","Not supported error 007"); 	
		createErrorEntry(15,"a","Not supported by data carrier 007"); 	
		createErrorEntry(16,"b","License error 007"); 	
		createErrorEntry(17,"c","Invalid configuration error 007"); 	
		createErrorEntry(18,"d","Head communication error 007"); 	
		createErrorEntry(19,"e","Multitag error 007"); 	
		createErrorEntry(20,"f",""); 		
		createErrorEntry(21,"g","Not supported error 007"); 	
		createErrorEntry(22,"h","Port error"); 	
		createErrorEntry(23,"i","Not supported error 007"); 	
		createErrorEntry(24,"j","Not supported error 007"); 	
		createErrorEntry(25,"N","Port error"); 	
		createErrorEntry(26,"k","Webserver error at reading of data carrier"); 	
	    createErrorEntry(26,"l","Webserver error at writing of data carrier"); 	
	}
	function createErrorEntry(entry,errorcode, errortext)
	{
		array[entry] = new Array();
		array[entry][0] = errorcode;
		array[entry][1] = errortext;	
	}
	
	this.searchArrayElement = function(errorcode)
	{
		for(var i = 0; i<array.length; i++)
		{
			if(String.fromCharCode(errorcode) == array[i][0])
			{	
				return array[i][1];
			}				
		}	
		return "Error code not defined";
	}
	//At creating of the object call the function to create the ErrorList
	createErrorList();
	
}


//listener for dropdown to refresh the headStatus informations

function refreshHeadStatusInformation()
{
	$.ajax({type:"POST", url: "dprop.jsn",error:errorResponse, success: dataResponseRefreshHeadStatus});
	window.setTimeout("refreshHeadStatusInformation()",1000); // 0,5 Sekunden		
		
}

function dataResponseRefreshHeadStatus(data)
{
	var headStatus = new HeadStatus();
	var index = 0; 
	switch($("#headnumber").val())
	{
		case "1":
			index = 0; 
		break;
		case "2":
			index = 1;
		break;
		case "3":
			index = 2;
		break;
		case "4":
			index = 3; 
		break;
		default: 
		break; 
	}
	headStatus.setHeadStatus(data[index].HeadType,data[index].HeadState,data[index].SerialNumberTag,data[index].HeadName);
}





//show some informations about read and write operation on the webserver (status textarea)
//param: result of the operation from the embedded Webserver
function printReadWriteResult(result)
{	
	var errorLog = new ErrorLog();
	errorLog.writeText("Result of read/write: "+errorList.searchArrayElement(result)+"\n");
}



//Function to write the adress data in the textarea of tagdata
function prepareAdressField(writedata)
{
	var startadress = parseInt($("#startadress").val());
	var numberofBytes = parseInt($("#length").val());
	var n= 0; 
	var spalte = -1;
	var Spaltenlaenge = 16;  
	var Restlaenge = 0;
	var dataAdressFieldValue = ""; 
	$("#tagdata").val("");
	
	for(i = 0; i< numberofBytes; i++)
	{
			if((i%Spaltenlaenge) == 0 )
			{
				spalte++;
				if(spalte != 0)
				{
					dataAdressFieldValue = dataAdressFieldValue+"\n"; 
				}
				for(n = (startadress + spalte*Spaltenlaenge).toString().length; n <= 6; n++ )
				{
					dataAdressFieldValue = dataAdressFieldValue+"0"; 
				}
				dataAdressFieldValue = dataAdressFieldValue+(startadress+spalte*Spaltenlaenge).toString(); 
				dataAdressFieldValue = dataAdressFieldValue+"\t   "; 
			}
			myHex = dataField[i+startadress].toString(16);
			dataAdressFieldValue = writeDataWithTwoCharacters(myHex,dataAdressFieldValue);
	}	
	$("#tagdata").val(dataAdressFieldValue);
}

function checkCommandValues()
{
	var startadress = parseInt($("#startadress").val());
	var numberofBytes = parseInt($("#length").val());
	
	if(startadress > 131072)
	{
		return false; 
	}
	if(numberofBytes > 8192)
	{
		return false; 
	}
	
	return true; 
	
	
}

function prepareAndWriteDataField(writeDataMode)
{
	var errorLog = new ErrorLog();
	var isValid = checkCommandValues();
	if(isValid)
	{
		writeData(writeDataMode);
		prepareAdressField(writeDataMode);
		writeValueToHiddenInput();
	}else
	{
		errorLog.clearErrorLog();
		errorLog.writeText("\nPlease check the value of startadress and length!\n");
	}
}

function writeValueToHiddenInput()
{
	var length = parseInt($("#length").val());
	var startadress = parseInt($("#startadress").val());
	var inputDataFieldHidden = "";
	inputDataFieldHidden = ""; 
	for(var i = startadress; i<length+startadress; i++)
	{
	   inputDataFieldHidden = inputDataFieldHidden + dataField[i] + ".";
	} 
	inputDataFieldHidden = inputDataFieldHidden+"\n"; 
	$("#writedata").val(inputDataFieldHidden);
	
}

function writeData(mode,i)
{
	var myHex = 0;
	var n = 0;
	var i = 0;
	var length = parseInt($("#length").val());
	var startadress = parseInt($("#startadress").val());
	
	for(i = startadress; i<= length+startadress; i++)
	{
		var dataValue = dataField[i]; 
		switch (mode)
		{
			case WriteDataField.increment: 
				dataValue = parseInt(dataValue) + 1;
				dataValue = checkData(dataValue); 
			break;
			case WriteDataField.decrement:
				dataValue--;
				dataValue = checkData(dataValue); 
				break;
			case WriteDataField.serial:
				dataValue = checkData(parseInt($("#startvalue").val())+(i-startadress));
				if(dataValue == 0)
				{
					dataValue = dataValue +((i-startadress)%256) ; 
				}
			break;
			case WriteDataField.fixedValue:
				dataValue = parseInt($("#startvalue").val());
				dataValue = checkData(dataValue); 
			break;
			case WriteDataField.standart:
				dataValue = 0;
				dataValue = checkData(dataValue); 
				break;
			case WriteDataField.readData:
				break;
			default:
				break;
		}
		dataField[i] = dataValue; 
	}
}

function checkData(data)
{
	if(data >255)
	{
		data = 0;
	}
	if(data < 0)
	{
		data = 255;
	}

return data; 	
}

function errorResponse()
{
	
	var errorLog = new ErrorLog();
	errorLog.clearErrorLog();
	errorLog.writeText("Error with data transfer to the device and from the device\n");
	$("#ReadWrite").removeAttr('disabled');
}

function dataResponse(data)
{
	var string = "readData"; 
	var daten = "";
	for (var i = 1; i<data.length; i++)
	{
		daten = daten + data[i].readData;
	}
	var datenArray = daten.split('.');
	var startadress = parseInt($("#startadress").val());
	for (var i = 0; i < datenArray.length-1; i++)
	{
		dataField[i+startadress] = parseInt(datenArray[i],16); 
	}
	printReadWriteResult(data[0].readwriteresult); 
	prepareAndWriteDataField(WriteDataField.readData);
    $("#ReadWrite").removeAttr('disabled');
}


function writeDataWithTwoCharacters(myHex,adressDataFieldValue)
{
	
	for(n = myHex.toString().length; n <= 1; n++ )
	{
		adressDataFieldValue = adressDataFieldValue + "0";
	}
	
	adressDataFieldValue = adressDataFieldValue+myHex+ " ";

	return adressDataFieldValue; 
}

function printStatusInformation(rwmode,headnumber,startadress,length)
{
	var errorLog = new ErrorLog();
	errorLog.clearErrorLog();
	errorLog.writeText("Head number: Head "+headnumber+"\n");
	errorLog.writeText("Operation length: "+length+"\n");
	errorLog.writeText("Startadress: "+startadress+"\n");
	switch(rwmode)
	{
		case 'read':
			errorLog.writeText("read pending ...\n" );
		break;
		case 'write':
			errorLog.writeText("write pending ...\n" );
		break;
		case 'crcinit':
			errorLog.writeText("write crc pending ...\n" );
		break;	
	}
}

function submitForm()
{
	$("#ReadWrite").attr('disabled','disabled');
	if (checkCommandValues())
	{		
		var startadress = $("#startadress").val();
		var headnumber = $("#headnumber").val();
		var length = $("#length").val();
		var writedata = $("#writedata").val();
		var rwmode = $("#rwmode").val();
		var dataString = "startadress="+startadress+"&";
		dataString = dataString+ "headnumber="+headnumber+"&";
		dataString = dataString+ "length="+length+"&";
		dataString = dataString+ "writedata="+writedata+"&";
		dataString = dataString+ "rwmode="+rwmode+"&";
		printStatusInformation(rwmode,headnumber,startadress,length);
		$.ajax({type:"POST", url: "RWHead.jsn", data: dataString,error: errorResponse, success: dataResponse});
	}
	return false;
}
