function getEventText(eventCode)
{
  var result = "";

  switch(eventCode)
    {
      case "0x0":
        result="";
        break;
      case "0x1":
        result="Short circuit";
        break;
      case "0x11":
        result="Short circuit";
        break;
      case "0x2":
        result=="Undervoltage";
        break;
      case "0x3":
        result="Overvoltage";
        break;
      case "0x4":
        result="Overload";
        break;
      case "0x5":
        result="Overtemperature";
        break;
      case "0x6":
        result="Line break, IO-Link connection lost";
        break;
      case "0x7":
        result="Upper limit exceeded";
        break;
      case "0x8":
        result="Lower limit underrun";
        break;
      case "0x9":
        result="Error";
        break;
      case "0x10":
        result="Sensor error";
        break;
      case "0x1A":
        result="Desina";
        break;
      case "0x1B":
        result="Wrong Sensor";
        break;
      case "0x37":
        result="Actor warning";
        break;
      case "0x38":
        result="Actor off";
        break;
      case "0x38":
        result="Actor break-off";
        break;
      case "0x39":
        result="Sensor supply";
        break;
      case "0x3c":
        result="Actor supply";
        break;
      case "0x1000":
        result="General malfunction - unknown error";
        break;
      case "0x4000":
        result="Temperature fault - Overload";
        break;
      case "0x4210":
        result="Device temperature over-run - Clear source of heat";
        break;
      case "0x4220":
        result="Device temperature under-run - Insulate Device";
        break;
      case "0x5000":
        result="Device hardware fault - Device exchange";
        break;
      case "0x5010":
        result="Component malfunction - Repair or exchange";
        break;
      case "0x5011":
        result="Non volatile memory loss - Check batteries";
        break;
      case "0x5012":
        result="Batteries low - Exchange batteries";
        break;
      case "0x5100":
        result="General power supply fault - Check availability";
        break;
      case "0x5101":
        result="Fuse blown/open - Exchange fuse";
        break;
      case "0x5110":
        result="Primary supply voltage over run - Check tolerance";
        break;
      case "0x5111":
        result="Primary supply voltage under run - Check tolerance";
        break;
      case "0x5112":
        result="Secondary supply voltage fault (Port Class B) - Check tolerance";
        break;
      case "0x6000":
        result="Device software fault - Check firmware revision";
        break;
      case "0x6320":
        result="Parameter error - Check data sheet and values";
        break;
      case "0x6321":
        result="Parameter missing - Check data sheet";
        break;
      case "0x6350":
        result="Parameter changed - Check configuration";
        break;
      case "0x7700":
        result="Wire break of a subordinate device - Check installation";
        break;
      case "0x7701":
        result="Wire break of subordinate device 1 - Check installation";
        break;
      case "0x7702":
        result="Wire break of subordinate device 2 - Check installation";
        break;
      case "0x7703":
        result="Wire break of subordinate device 3 - Check installation";
        break;
      case "0x7704":
        result="Wire break of subordinate device 4 - Check installation";
        break;
      case "0x7705":
        result="Wire break of subordinate device 5 - Check installation";
        break;
      case "0x7706":
        result="Wire break of subordinate device 6 - Check installation";
        break;
      case "0x7707":
        result="Wire break of subordinate device 7 - Check installation";
        break;
      case "0x7708":
        result="Wire break of subordinate device 8 - Check installation";
        break;
      case "0x7709":
        result="Wire break of subordinate device 9 - Check installation";
        break;
      case "0x770A":
        result="Wire break of subordinate device 10 - Check installation";
        break;
      case "0x770B":
        result="Wire break of subordinate device 11 - Check installation";
        break;
      case "0x770C":
        result="Wire break of subordinate device 12 - Check installation";
        break;
      case "0x770D":
        result="Wire break of subordinate device 13 - Check installation";
        break;
      case "0x770E":
        result="Wire break of subordinate device 14 - Check installation";
        break;
      case "0x770F":
        result="Wire break of subordinate device 15 - Check installation";
        break;
      case "0x7710":
        result="Short circuit - Check installation";
        break;
      case "0x7711":
        result="Ground fault - Check installation";
        break;
      case "0x8C00":
        result="Technology specific application fault - Reset Device";
        break;
      case "0x8C01":
        result="Simulation active - Check operational mode";
        break;
      case "0x8C10":
        result="Process variable range over-run - Process Data uncertain";
        break;
      case "0x8C20":
        result="Measurement range over-run - Check application";
        break;
      case "0x8C30":
        result="Process variable range over-run - Process Data uncertain";
        break;
      case "0x8C40":
        result="Maintenance required - Cleaning";
        break;
      case "0x8C41":
        result="Maintenance required - Refill";
        break;
      case "0x8C42":
        result="Maintenance required - Exchange wear and tear parts";
        break;
      default:
        result="Unknown Event: " + eventCode;
        break;
    }
    return result;
}

function markCurrentSite(currentUrl)
{
    switch (currentUrl.split("/")[currentUrl.split("/").length - 1].toLowerCase()) {
      case "":
      case "index.htm":
        document.getElementById("HomeIcon").className = "Symbols_right Marked";
        break;
	  case "dprop.htm":
        document.getElementById("PortsIcon").className = "Symbols_right Marked";
        break;
      case "user.htm":
        document.getElementById("UserIcon").className = "Symbols_right Marked";
        break;
      case "setup.htm":
      case "setRFID.htm":  
	  case "RWHead.htm":
		document.getElementById("SetupIcon").className = "Symbols_right Marked";
        break;
      case "log.htm":
        document.getElementById("LogIcon").className = "Symbols_right Marked";
        break;
      case "contact.htm":
        document.getElementById("HelpIcon").className = "Symbols_right Marked";
        break;
    }
}

   function navigateSetup(Site,login ) {
    switch (Site) {
      case 5:
        if (login == "1") window.open("setup.htm?Tab=1", "_top");
        else window.open("user.htm?site=setup1", "_top");
        break;
	  case 6:
        if (login== "1") window.open("setup.htm?Tab=2", "_top");
        else window.open("user.htm?site=setup2", "_top");
        break;
	  case 7:
        if (login == "1") window.open("setRFID.htm", "_top");
        else window.open("user.htm?site=setRFID", "_top");
        break;	
	  case 8:
        if (login == "1") window.open("RWHead.htm", "_top");
        else window.open("user.htm?site=RWHead", "_top");
        break;	
    }
  }

   function navigate(Site ) {
    switch (Site) {
      case 1:
        window.open("/", "_top");
        break;
      case 2:
        window.open("dprop.htm", "_top");
        break;
      case 4:
        window.open("user.htm", "_top");
        break;
      case 8:
        window.open("contact.htm", "_top");
        break;
      case 9:
        window.open("http://www.balluff.com/", "_blank");
        break;
      case 10:
        window.open("log.htm", "_top");
        break;
    }
  }
  
  function showTab(index) {
    for (var i = 1; i <= this.tabCount; i++) {
      document.getElementById("Tab" + i.toString()).style.display = "none";
    }
    if (document.getElementById("Tab" + index) != null) document.getElementById("Tab" + index).style.display = "";
    ResponsiveDynamic.toggleMenu(false);
    if (this.tabCount > 1) {
      var elements = document.getElementById("NavFrame").getElementsByTagName("DIV");
      for (var i = 0; i < elements.length; i++) {
        if (elements[i].className == "Menu_DropDown") {
          var links = elements[i].getElementsByTagName("A");
          if (links[0].href.substring(0, 11) == "javascript:") {
            for (var j = 0; j < links.length; j++) {
              links[j].style.fontWeight = "";
              links[j].style.backgroundColor = "";
              links[j].style.color = "";
              if (j == window.parseInt(index, 10) - 1) {
                links[j].style.color = "White";
                links[j].style.fontWeight = "bold";
                links[j].style.backgroundColor = "#A0A0A0";
              }
            }
          }
        }
      }
    }
  }

function decimalToHex(d) 
{
  var hex = Number(d).toString(16);
  hex = "".substr(0, 6 - hex.length) + hex; 
  return "0x"+hex.toUpperCase();
}
